
UserBO = {}

-- function __G__TRACKBACK__(errorMessage)
--     print("----------------------------------------")
--     print("LUA ERROR: " .. tostring(errorMessage) .. "\n")
--     print(debug.traceback("", 2))
--     print("----------------------------------------")
-- end

local tickTimer_ = nil

local cycleTimers_ = {} -- 多个属性用于恢复的倒计时

function UserBO.logout()
	gprint("UserBO.logout...")
	if ActivityMO.refreshHandler_ then
		scheduler.unscheduleGlobal(ActivityMO.refreshHandler_)
		ActivityMO.refreshHandler_ = nil
	end

	if ActivityCenterMO.refreshHandler_ then
		scheduler.unscheduleGlobal(ActivityCenterMO.refreshHandler_)
		ActivityCenterMO.refreshHandler_ = nil
	end

	ChatMO.chat_ = {}
	ChatMO.man_ = {}
	ChatMO.shield_ = {}
	-- ChatMO.showChat_ = true
	ChatMO.searchContent_ = ""
	ChatMO.curPrivacyLordId_ = 0

	RankMO.myRank_ = {}
	RankMO.ranks = {}
end

function UserBO.parseSynResource(name, code, data)
	local deltaResData = data
	local function parseResource(name, code, data)
		if not handleCode(name, code, data) then
			local delta = UserBO.updateGetResource(data)
			-- gdump(delta, "资源变化")

			local res = {}
			res[#res + 1] = {kind = ITEM_KIND_RESOURCE, id = RESOURCE_ID_COPPER, count = deltaResData.copper}
			res[#res + 1] = {kind = ITEM_KIND_RESOURCE, id = RESOURCE_ID_IRON, count = deltaResData.iron}
			res[#res + 1] = {kind = ITEM_KIND_RESOURCE, id = RESOURCE_ID_OIL, count = deltaResData.oil}
			res[#res + 1] = {kind = ITEM_KIND_RESOURCE, id = RESOURCE_ID_SILICON, count = deltaResData.silicon}
			res[#res + 1] = {kind = ITEM_KIND_RESOURCE, id = RESOURCE_ID_STONE, count = deltaResData.stone}

			UiUtil.showAwards({awards = res})
		end
	end

	SocketWrapper.wrapSend(parseResource, NetRequest.new("GetResource"))
end

-- 当有影响战斗力的事件发生时，需要处理是否玩家战斗力有变化
function UserBO.triggerFightCheck()
	if not UserMO.startCheckFight_ then return end

	if ArmyMO.dirtyArmyData_ or TankMO.dirtyTankData_ or HeroMO.dirtyHeroData_ or SkillMO.dirtySkillData_
		or ScienceMO.dirtyScienceData_ or PartyMO.dirtyPartyScienceData_ then return end

	local maxFormation = TankBO.getMaxFightFormation(TankBO.getMaxFightValueTanks(), true)
	local data = TankBO.analyseFormation(maxFormation)
	-- gdump(data, "UserBO.triggerFightCheck")
	data.total = math.floor(data.total)
	if data.total ~= UserMO.fightValue_ then  -- 战斗力有变化
		if UserMO.fightShowScheduler_ then
			-- gprint("UserBO.triggerFightCheck one trigger has be destroy!!!!!! HaHaHaHaHa")
			scheduler.unscheduleGlobal(UserMO.fightShowScheduler_)
			UserMO.fightShowScheduler_ = nil
		end

		-- 延迟发送，避免多个地方触发，而导致重复发送
		UserMO.fightShowScheduler_ = scheduler.performWithDelayGlobal(function()
				local function doneSetData()
					UserMO.fightShowScheduler_ = nil

					local old = math.floor(UserMO.fightValue_)
					UserMO.fightValue_ = data.total

					if UiDirector.hasUiByName("HomeView") then UiUtil.showFightChange(old, data.total, {formation = maxFormation, analyse = data}) end

					Notify.notify(LOCAL_FIGHT_EVENT)
				end
				UserBO.asynSetData(doneSetData, 1, data.total)
			end, 0.4)
	end
end

-- 统计征战关卡的总星数，并上传
function UserBO.triggerCombatStar()
	local star = 0
	for combatId, combat in pairs(CombatMO.combats_) do
		star = star + combat.star
	end

	local function doneSetData()
	end
	UserBO.asynSetData(doneSetData, 2, star)
end

-- 目前只统计攻击、暴击、和闪避
function UserBO.triggerEquip(equipPos)
	if equipPos ~= EQUIP_POS_ATK and equipPos ~= EQUIP_POS_DODGE and equipPos ~= EQUIP_POS_CRIT then return end

	local keyId = 0
	local level = 0

	for formatIndex = 1, FIGHT_FORMATION_POS_NUM do
		if EquipBO.hasEquipAtPos(formatIndex, equipPos) then
			local equip = EquipBO.getEquipAtPos(formatIndex, equipPos)
			if equip.level > level then
				level = equip.level
				keyId = equip.keyId
			end
		end
	end

	if keyId <= 0 then return end

	local dataType = 0
	if equipPos == EQUIP_POS_ATK then dataType = 4
	elseif equipPos == EQUIP_POS_CRIT then dataType = 5
	elseif equipPos == EQUIP_POS_DODGE then dataType = 6
	end

	local function doneSetData()
	end
	UserBO.asynSetData(doneSetData, dataType, keyId)
end

function UserBO.triggerHonor()
	-- local function doneSetData()
	-- end
	-- UserBO.asynSetData(doneSetData, 3, UserMO.honor_)
end

function UserBO.parsePortrait(portrait)
	local v1 = portrait % 100  -- 头像
	local v2 = math.floor(portrait / 100)  -- 挂件
	return v1, v2
end

function UserBO.updateGetLord(data)
	gdump(data, "UserBO GetLord")

	local res = {}

	UserMO.lordId_ = data.lordId
	UserMO.nickName_ = data.nick
	local p, q = UserBO.parsePortrait(data.portrait)
	UserMO.portrait_ = p
	UserMO.pendant_ = q
	UserMO.level_ = data.level
	local old = UserMO.exp_
	UserMO.exp_ = data.exp
	local count = UserMO.exp_ - old
	res[#res + 1] = {kind = ITEM_KIND_EXP, count = count}
	UserMO.vip_ = data.vip
	UserMO.topup_ = data.topup
	UserMO.coin_ = data.gold
	UserMO.rank_ = data.ranks
	UserMO.command_ = data.command
	UserMO.fame_ = data.fame
	UserMO.fameLevel_ = data.fameLv

	local oldHonor = UserMO.honor_
	UserMO.honor_ = data.honour

	UserMO.prosperous_ = data.pros
	UserMO.maxProsperous_ = data.prosMax
	UserMO.prosperousLevel_ = UserBO.getProsperousLevel(data.pros)
	UserMO.power_ = data.power
	UserMO.powerTime_ = data.powerTime
	UserMO.fightValue_ = data.fight
	UserMO.newerGift_= data.newerGift
	UserMO.equipWarhouse_ = data.equip
	UserMO.huangbao_ = data.huangbao
	UserMO.canClickFame_ = data.clickFame
	UserMO.canBuyFame_ = data.buyFame
	UserMO.sex_ = data.sex
	UserMO.powerBuy_ = data.buyPower
	UserMO.newState = data.newState
	if UserMO.sex_ == 0 then
		UserMO.sex_ = SEX_MALE
	end
	UserMO.buildCount_ = data.buildCount

	UserMO.onlineAccumTime_ = data.olTime

	UserMO.onlineCdTime_ = data.ctTime
	UserMO.onlineAwardIndex_ = data.olAward  -- 已经领取了的索引

	UserMO.gem_ = 0
	if table.isexist(data, "gm") then UserMO.gm_ = data.gm end

	if table.isexist(data, "createRoleTime") then UserMO.createRoleTime_ = data.createRoleTime end

	if table.isexist(data, "partyTipAward") then UserMO.partyTipAward_ = data.partyTipAward end

	UserMO.guider_ = 0
	if table.isexist(data, "guider") then UserMO.guider_ = data.guider end

	if table.isexist(data, "staffing") then UserMO.staffing_ = data.staffing end

	if table.isexist(data, "staffingLv") then UserMO.staffingLv_ = data.staffingLv end

	if table.isexist(data, "staffingExp") then UserMO.staffingExp_ = data.staffingExp end

	if UserMO.onlineAwardIndex_ >= UserMO.getOnlineAwardTotalNum() then -- 当天的所有的都领完了
		UserMO.onlineCdTime_ = 0
	else -- 还有在线奖励可以领取
		local time = UserMO.getOnlineAwardByIndex(UserMO.onlineAwardIndex_ + 1)
		-- gprint("xxxx time:", time, ManagerTimer.getTime(), (ManagerTimer.getTime() - UserMO.onlineCdTime_))
		UserMO.onlineCdTime_ = time - (ManagerTimer.getTime() - UserMO.onlineCdTime_) + 0.99
	end
	-- gprint("UserBO.updateGetLord", UserMO.onlineCdTime_)

	WorldMO.updatePos(data.pos)

	CombatMO.combatChallenge_ = {}
	CombatMO.combatBuy_ = {}
	for index = 1, EXPLORE_TYPE_LIMIT do
		CombatMO.combatChallenge_[index] = {}
		CombatMO.combatBuy_[index] = {}

		if index == EXPLORE_TYPE_EQUIP then
			CombatMO.combatChallenge_[index].count = data.equipEplr
			CombatMO.combatBuy_[index].count = data.equipBuy
		elseif index == EXPLORE_TYPE_PART then
			CombatMO.combatChallenge_[index].count = data.partEplr
			CombatMO.combatBuy_[index].count = data.partBuy
		elseif index == EXPLORE_TYPE_EXTREME then
			CombatMO.combatChallenge_[index].count = data.extrEplr
			CombatMO.combatBuy_[index].count = data.extrReset  -- 极限副本已重置次数
		elseif index == EXPLORE_TYPE_LIMIT then
			CombatMO.combatChallenge_[index].count = data.timeEplr
			CombatMO.combatBuy_[index].count = 0
		end
	end

	-- 配件材料信息
	PartMO.material_ = {}
	PartMO.material_[MATERIAL_ID_FITTING] = {id = MATERIAL_ID_FITTING, count = data.fitting}
	PartMO.material_[MATERIAL_ID_METAL] = {id = MATERIAL_ID_METAL, count = data.metal}
	PartMO.material_[MATERIAL_ID_PLAN] = {id = MATERIAL_ID_PLAN, count = data.plan}
	PartMO.material_[MATERIAL_ID_MINERAL] = {id = MATERIAL_ID_MINERAL, count = data.mineral}
	PartMO.material_[MATERIAL_ID_TOOL] = {id = MATERIAL_ID_TOOL, count = data.tool}
	PartMO.material_[MATERIAL_ID_DRAW] = {id = MATERIAL_ID_DRAW, count = data.draw}

	-- gprint("等级是:", UserMO.prosperousLevel_)

	local timer = cycleTimers_[ITEM_KIND_POWER]   -- 体力定时器
	if not timer then
		cycleTimers_[ITEM_KIND_POWER] = require("app.util.CycleTimer").new(data.powerTime, POWER_CYCLE_TIME)
	else
		cycleTimers_[ITEM_KIND_POWER]:setDeltaTime(data.powerTime)
	end
	cycleTimers_[ITEM_KIND_POWER]:start()
	UserBO.updateCycleTime(ITEM_KIND_POWER)

	local timer = cycleTimers_[ITEM_KIND_PROSPEROUS]  -- 繁荣度定时器
	if not timer then
		cycleTimers_[ITEM_KIND_PROSPEROUS] = require("app.util.CycleTimer").new(data.prosTime, PROSPEROUS_CYCLE_TIME)
	else
		cycleTimers_[ITEM_KIND_PROSPEROUS]:setDeltaTime(data.prosTime)
	end
	cycleTimers_[ITEM_KIND_PROSPEROUS]:start()
	UserBO.updateCycleTime(ITEM_KIND_PROSPEROUS)

	if not UserMO.tickTimer_ then
		UserMO.tickTimer_ = ManagerTimer.addTickListener(UserBO.onTick)
	end

	if not UserMO.refreshTimer_ then  -- 每日的刷新时间
		UserMO.refreshTimer_ = ManagerTimer.addClockListener(0, UserBO.refreshCallback)
	end

	if oldHonor ~= UserMO.honor_ then
		UserBO.triggerHonor()
	end

	Notify.notify(LOCAL_RES_EVENT, {tag = 3})
	Notify.notify(LOCAL_EXP_EVENT)
	Notify.notify(LOCAL_LEVEL_EVENT)
	Notify.notify(LOCAL_FAME_EVENT)
	Notify.notify(LOCAL_POWER_EVENT)
	Notify.notify(LOCAL_PROSPEROUS_EVENT)
	return res
end

function UserBO.refreshCallback()
	gprint("UserBO.refreshCallback next day refresh !!!")
	UserBO.asynGetLord()
	SocketWrapper.wrapSend(function(name, code, data) if not handleCode(name, code, data) then SignBO.update(data) end end, NetRequest.new("GetSign"))
	SocketWrapper.wrapSend(function(name, code, data) if not handleCode(name, code, data) then SignBO.updateEveryLogin(data) end end, NetRequest.new("EveLogin"))
	SocketWrapper.wrapSend(function(name, code, data) if not handleCode(name, code, data) then ActivityBO.update(data) end end, NetRequest.new("GetActivityList"))
	SocketWrapper.wrapSend(function(name, code, data) if not handleCode(name, code, data) then LotteryBO.updateTreasureFreeTimes(data) end end, NetRequest.new("GetLotteryExplore"))
	SocketWrapper.wrapSend(function(name, code, data) if not handleCode(name, code, data) then ActivityCenterBO.update(data) end end, NetRequest.new("GetActionCenter"))

	if not UserMO.refreshTimer_ then
		UserMO.refreshTimer_ = ManagerTimer.addClockListener(0, UserBO.refreshCallback)
	end
end

function UserBO.updateGetResource(data)
	-- gdump(data, "GetResource")
	if not UserMO.resource_[RESOURCE_ID_COPPER] then UserMO.resource_[RESOURCE_ID_COPPER] = 0 end
	if not UserMO.resource_[RESOURCE_ID_IRON] then UserMO.resource_[RESOURCE_ID_IRON] = 0 end
	if not UserMO.resource_[RESOURCE_ID_OIL] then UserMO.resource_[RESOURCE_ID_OIL] = 0 end
	if not UserMO.resource_[RESOURCE_ID_SILICON] then UserMO.resource_[RESOURCE_ID_SILICON] = 0 end
	if not UserMO.resource_[RESOURCE_ID_STONE] then UserMO.resource_[RESOURCE_ID_STONE] = 0 end

	local res = {}
	res[#res + 1] = {kind = ITEM_KIND_RESOURCE, id = RESOURCE_ID_COPPER, count = data.copper}
	res[#res + 1] = {kind = ITEM_KIND_RESOURCE, id = RESOURCE_ID_IRON, count = data.iron}
	res[#res + 1] = {kind = ITEM_KIND_RESOURCE, id = RESOURCE_ID_OIL, count = data.oil}
	res[#res + 1] = {kind = ITEM_KIND_RESOURCE, id = RESOURCE_ID_SILICON, count = data.silicon}
	res[#res + 1] = {kind = ITEM_KIND_RESOURCE, id = RESOURCE_ID_STONE, count = data.stone}

	local delta = UserBO.updateResources(res)
	return delta
end

-- 玩家的等级level是否是满级了
function UserBO.isLordFullLevel()
	local level = UserMO.level_
	if level >= UserMO.queryMaxLordLevel() then return true
	else return false end
end

-- 根据繁荣值，确定繁荣度等级
function UserBO.getProsperousLevel(prosperous)
	local lv = 0
	local maxLv = UserMO.queryMaxProsperousLevel()
	-- print("最大繁荣度等级 pros lv:", maxLv)
	for index = 1, maxLv do
		local prosData = UserMO.queryProsperousByLevel(index)
		if prosData.prosExp > prosperous then
			return lv
		else
			lv = index
		end
	end
	return maxLv
end

function UserBO.getCycleTime(kind)
	if not cycleTimers_[kind] then return 0 end
	
	return cycleTimers_[kind]:getLeftTime()
end

function UserBO.updateCycleTime(kind)
	local timer = cycleTimers_[kind]
	if not timer then return end

	local needTime = 0

	if kind == ITEM_KIND_POWER then
		if UserMO.power_ >= POWER_MAX_VALUE then
			timer:stop()
			return
		end
		needTime = POWER_CYCLE_TIME
	elseif kind == ITEM_KIND_PROSPEROUS then
		if UserMO.prosperous_ >= UserMO.maxProsperous_ then
			timer:stop()
			return
		end
		needTime = PROSPEROUS_CYCLE_TIME
	end

	if not timer:isStart() then  -- 如果之前属性是达到了上限，而定时器没有运行，则现在需要运行了
		timer:start()
		timer:setDeltaTime(needTime)
	end
end

-- 可带兵数量详情
-- commander:指挥官
function UserBO.getTakeTank(commander)
	local takeTank = 0
	local lord = UserMO.queryLordByLevel(UserMO.level_)  -- 玩家等级
	takeTank = takeTank + lord.tankCount

	local pros = UserMO.queryProsperousByLevel(UserMO.prosperousLevel_)  -- 繁荣度
	takeTank = takeTank + pros.tankCount

	local command = UserMO.queryCommandByLevel(UserMO.command_)  -- 统率
	if not command then
		command = {}
		command.tankCount = 0
	end
	takeTank = takeTank + command.tankCount

	if commander and commander > 0 then  -- 指挥官
		local heroDB = HeroMO.queryHero(commander)
		if heroDB.tankCount > 0 then
			takeTank = takeTank + heroDB.tankCount
		end
	end

	-- 总带兵数量，等级带兵数量，繁荣度可带兵数量
	return takeTank, lord.tankCount, pros.tankCount, command.tankCount
end

function UserBO.onTick(dt)
	if UserMO.onlineCdTime_ > 0 then
		UserMO.onlineCdTime_ = UserMO.onlineCdTime_ - dt
	end

	for kind, timer in pairs(cycleTimers_) do
		local t, c = timer:calculate()
		if c > 0 then
			gprint("[UserBO] on Tick 添加cycle值:" , c, "kind:", kind)
			local _, award = UserBO.addCycleResource(kind, c, false)

			if kind == ITEM_KIND_POWER then
				UiUtil.showAwards({awards = {award}})
			end
		end
	end

	-- print("体力剩余时间:" .. cycleTimers_[ITEM_KIND_POWER]:getLeftTime(), UserMO.power_)
	-- print("繁荣度剩余时间:" .. cycleTimers_[ITEM_KIND_PROSPEROUS]:getLeftTime(), UserMO.prosperous_)
end

function UserBO.addResources(resources)
	if not resources then return end

	local function add(kind, count, id)
		if count <= 0 then return 0 end
		local num = UserMO.getResource(kind, id)

		if kind == ITEM_KIND_COIN then
			UserMO.coin_ = UserMO.coin_ + count
			return 1
		elseif kind == ITEM_KIND_RESOURCE then
			UserMO.resource_[id] = UserMO.resource_[id] + count
			return 1
		elseif kind == ITEM_KIND_HONOR then
			UserMO.honor_ = UserMO.honor_ + count
			return 6
		elseif kind == ITEM_KIND_MATERIAL then
			if PartMO.material_[id] then 
				PartMO.material_[id].count = PartMO.material_[id].count + count 
				--TK统计 获得配件材料
				TKGameBO.onEvnt(TKText.eventName[13], {partId = id, count = count})
			end
			return 5
		elseif kind == ITEM_KIND_PROP then  -- 道具
			if PropMO.prop_[id] then 
				PropMO.prop_[id].count = PropMO.prop_[id].count + count
			else 
				PropMO.prop_[id] = {propId = id, count = count} 
			end
			--TK统计 获得道具
			TKGameBO.onEvnt(TKText.eventName[5], {propId = id, count = count})
			return 2
		elseif kind == ITEM_KIND_TANK then  -- 坦克
			if TankMO.tanks_[id] then TankMO.tanks_[id].count = TankMO.tanks_[id].count + count
			else TankMO.tanks_[id] = {tankId = id, count = count, rest = 0} end
			return 3
		elseif kind == ITEM_KIND_CHIP then -- 部件碎片
			if PartMO.chip_[id] then 
				PartMO.chip_[id].count = PartMO.chip_[id].count + count
			else 
				PartMO.chip_[id] = {chipId = id, count = count} 
			end
			--TK统计 获得配件碎片
			TKGameBO.onEvnt(TKText.eventName[11], {partId = id, count = count})
			return 4
		elseif kind == ITEM_KIND_SCORE then -- 竞技场积分
			ArenaMO.arenaScore_ = ArenaMO.arenaScore_ + count
			return 7
		elseif kind == ITEM_KIND_HUANGBAO then
			UserMO.huangbao_ = UserMO.huangbao_ + count
			return 8
		elseif kind == ITEM_KIND_CONTRIBUTION then
			PartyMO.myDonate_ = PartyMO.myDonate_ + count
		end
		return 0
	end

	local change = {}
	for key, resource in pairs(resources) do
		local value = add(resource.kind, resource.count, resource.id)
		change[value] = true
	end

	-- 资源发生了变化
	if change[1] then Notify.notify(LOCAL_RES_EVENT, {tag = 1}) end  -- tag = 1,资源是增加
	-- 道具发生了变化
	if change[2] then Notify.notify(LOCAL_PROP_EVENT) end
	-- 坦克发生了变化
	if change[3] then Notify.notify(LOCAL_TANK_EVENT) end
	-- 积分
	if change[7] then Notify.notify(LOCAL_SCORE_EVENT) end
	-- 9 用于装备
end

function UserBO.addResource(kind, count, id)
	if count <= 0 then return -1 end
	UserBO.addResources({{kind = kind, count = count, id = id}})
end

-- 批量减少资源
function UserBO.reduceResources(resources)
	if not resources then return end

	local function reduce(kind, count, id)
		if count <= 0 then return 0 end

		local num = UserMO.getResource(kind, id)
		if num < count then return 0 end

		if kind == ITEM_KIND_COIN then
			UserMO.coin_ = UserMO.coin_ - count
			--任务计数
			TaskBO.updateTaskSchedule({kind = TASK_SCHEDULE_KIND_COIN_COST,type = 1})

			if ActivityBO.isValid(ACTIVITY_ID_COST_GOLD) then ActivityBO.asynGetActivityContent(nil, ACTIVITY_ID_COST_GOLD) end
			return 1
		elseif kind == ITEM_KIND_RESOURCE then
			UserMO.resource_[id] = UserMO.resource_[id] - count
			return 1
		elseif kind == ITEM_KIND_MATERIAL then
			PartMO.material_[id].count = PartMO.material_[id].count - count
			--TK统计 消耗配件材料
			TKGameBO.onEvnt(TKText.eventName[14], {partId = id, count = count})
			return 5
		elseif kind == ITEM_KIND_PROP then  -- 道具
			if PropMO.prop_[id] then
				PropMO.prop_[id].count = PropMO.prop_[id].count - count
				--TK统计 消耗道具
				TKGameBO.onEvnt(TKText.eventName[6], {propId = id, count = count})
				TKGameBO.onUse(PropMO.getPropName(id), count)
				return 2
			end
		elseif kind == ITEM_KIND_TANK then  -- 坦克
			if TankMO.tanks_[id] then
				TankMO.tanks_[id].count = TankMO.tanks_[id].count - count
				return 3
			end
		elseif kind == ITEM_KIND_CHIP then -- 部件碎片
			if PartMO.chip_[id] then
				PartMO.chip_[id].count = PartMO.chip_[id].count - count
				--TK统计 消耗配件碎片
				TKGameBO.onEvnt(TKText.eventName[12], {partId = id, count = count})
				return 4
			end
		elseif kind == ITEM_KIND_HUANGBAO then
			UserMO.huangbao_ = UserMO.huangbao_ - count
			return 8
		end
		return 0
	end

	local change = {}
	for key, resource in pairs(resources) do
		local value = reduce(resource.kind, resource.count, resource.id)
		change[value] = true
	end

	-- 资源发生了变化
	if change[1] then Notify.notify(LOCAL_RES_EVENT, {tag = 2}) end  -- tag = 2,资源是减少
	-- 道具发生了变化
	if change[2] then Notify.notify(LOCAL_PROP_EVENT) end
	-- 坦克发生了变化
	if change[3] then Notify.notify(LOCAL_TANK_EVENT) end
	-- 9 用于装备
end

-- 只用减少一个资源
function UserBO.reduceResource(kind, count, id)
	if count <= 0 then return -1 end
	UserBO.reduceResources({{kind = kind, count = count, id = id}})
end

-- 设置资源的数量，资源的数量被重置
function UserBO.updateResources(resources)
	if not resources then return end

	local function update(kind, count, id)
		local delta = {}
		delta.kind = kind
		delta.id = id

		if kind == ITEM_KIND_COIN then
			if UserMO.coin_ ~= count then
				delta.count = count - UserMO.coin_
				UserMO.coin_ = count
				if delta.count < 0 then
					--任务计数
					TaskBO.updateTaskSchedule({kind = TASK_SCHEDULE_KIND_COIN_COST,type = 1})
				end

				if ActivityBO.isValid(ACTIVITY_ID_COST_GOLD) then ActivityBO.asynGetActivityContent(nil, ACTIVITY_ID_COST_GOLD) end
				return 1, delta
			end
		elseif kind == ITEM_KIND_RESOURCE then
			if UserMO.resource_[id] ~= count then
				delta.count = count - UserMO.resource_[id]
				UserMO.resource_[id] = count
				return 1, delta
			end
		elseif kind == ITEM_KIND_MATERIAL then
			if PartMO.material_[id].count ~= count then
				delta.count = count - PartMO.material_[id].count
				if delta.count > 0 then
					--TK统计 获得配件碎片
					TKGameBO.onEvnt(TKText.eventName[13], {partId = id, count = delta.count})
				elseif delta.count < 0 then
					--TK统计 消耗配件碎片
					TKGameBO.onEvnt(TKText.eventName[14], {partId = id, count = -delta.count})
				end
				PartMO.material_[id].count = count
				return 5, delta
			end
		elseif kind == ITEM_KIND_PROP then  -- 道具
			if not PropMO.prop_[id] then PropMO.prop_[id] = {propId = id, count = 0} end

			if PropMO.prop_[id].count ~= count then
				delta.count = count - PropMO.prop_[id].count
				if delta.count > 0 then
					--TK统计 获得道具
					TKGameBO.onEvnt(TKText.eventName[5], {propId = id, count = delta.count})
				elseif delta.count < 0 then
					--TK统计 消耗道具
					TKGameBO.onEvnt(TKText.eventName[6], {propId = id, count = -delta.count})
					TKGameBO.onUse(PropMO.getPropName(id), -delta.count)
				end
				PropMO.prop_[id].count = count
				return 2, delta
			end
		elseif kind == ITEM_KIND_TANK then -- 坦克
			if not TankMO.tanks_[id] then TankMO.tanks_[id] = {tankId = id, count = 0, rest = 0} end

			if TankMO.tanks_[id].count ~= count then
				delta.count = count - TankMO.tanks_[id].count
				TankMO.tanks_[id].count = count
				return 3, delta
			end
		elseif kind == ITEM_KIND_CHIP then -- 配件碎片
			if not PartMO.chip_[id] then PartMO.chip_[id] = {chipId = id, count = 0} end

			if PartMO.chip_[id].count ~= count then
				delta.count = count - PartMO.chip_[id].count
				if delta.count > 0 then
					--TK统计 获得配件碎片
					TKGameBO.onEvnt(TKText.eventName[11], {partId = id, count = delta.count})
				elseif delta.count < 0 then
					--TK统计 消耗配件碎片
					TKGameBO.onEvnt(TKText.eventName[12], {partId = id, count = -delta.count})
				end
				PartMO.chip_[id].count = count
				return 4, delta
			end
		elseif kind == ITEM_KIND_SCORE then
			delta.count = count - ArenaMO.arenaScore_
			ArenaMO.arenaScore_ = count
			return 7, delta
		end
		return 0
	end
	local change = {}
	local dt = {}
	for key, resource in pairs(resources) do
		local value, delta = update(resource.kind, resource.count, resource.id)
		change[value] = true
		dt[#dt + 1] = delta
	end

	-- 资源发生了变化
	if change[1] then Notify.notify(LOCAL_RES_EVENT, {tag = 3}) end  -- tag = 3,资源是更新
	-- 道具发生了变化
	if change[2] then Notify.notify(LOCAL_PROP_EVENT) end
	-- 坦克发生了变化
	if change[3] then Notify.notify(LOCAL_TANK_EVENT) end
	-- 配件碎片发生了变化
	if change[4] then end
	-- 零件、蓝图、矿物、工具等等发生了变化
	if change[5] then end
	-- 积分
	if change[7] then Notify.notify(LOCAL_SCORE_EVENT) end
	-- 9 用于装备

	return dt
end

function UserBO.updateResource(kind, count, id)
	local delta = UserBO.updateResources({{kind = kind, count = count, id = id}})
	return delta
end

-- 用于添加exp等可提升等级的属性值
-- 返回最新的等级、经验、以及是否有升级
function UserBO.addUpgradeResouce(kind, count, id)
	if count <= 0 then
		error("[UserMO] add upgrade resource. count is ERROR.", count, "kind:", kind, "id:", id)
	end

	if kind == ITEM_KIND_EXP then  -- 添加经验
		local maxLevel = UserMO.queryMaxLordLevel()

		local newExp = UserMO.exp_ + count
		local copyLevel = UserMO.level_
		local curLevel = UserMO.level_

		if curLevel >= maxLevel then return UserMO.level_, UserMO.exp_, false end

		local needExp = UserMO.queryLordByLevel(UserMO.level_ + 1).needExp
		if newExp < needExp then -- 没有升级
			UserMO.exp_ = newExp
			Notify.notify(LOCAL_EXP_EVENT)
			return UserMO.level_, UserMO.exp_, false
		end
		
		while newExp >= needExp do  -- 升级了
			curLevel = curLevel + 1
			newExp = newExp - needExp

			UserMO.level_ = curLevel
			--TK统计 设定等级
			TKGameBO.setLevel(UserMO.level_)
			UserMO.exp_ = newExp

			-- 达到装备的上限
			if curLevel >= maxLevel then
				UserMO.exp_ = 0
				break
			end
			needExp = UserMO.queryLordByLevel(UserMO.level_ + 1).needExp

			--如果升到2级同时没有坐标则完成引导，获取坐标
			if UserMO.level_ == 3 and (WorldMO.pos_.x < 0 or WorldMO.pos_.y < 0) then
				NewerBO.asynDoneGuide()
			end
			--拇指玩和草花的升级统计
			if GameConfig.environment == "u8_dgwm" or GameConfig.environment == "u8_dgzfz" 
				or GameConfig.environment == "n_uc_client" or GameConfig.environment == "ucDgwm_client" then
				ServiceBO.userLevelUp()
			end
			
		end
		UserBO.triggerFightCheck()  -- 等级提升可能会开放战斗阵型位置，从而影响战斗力

		TankBO.checkFormationUnlock(copyLevel, UserMO.level_) -- 判断阵型是否有位置解锁

		PartBO.checkPositionUnlock(copyLevel, UserMO.level_)

		ActivityBO.trigger(ACTIVITY_ID_LEVEL_RANK)

		Notify.notify(LOCAL_EXP_EVENT)
		Notify.notify(LOCAL_LEVEL_EVENT)
		return UserMO.level_, UserMO.exp_, true
	elseif kind == ITEM_KIND_FAME then -- 声望
		local newFame = UserMO.fame_ + count
		local curLevel = UserMO.fameLevel_

		local needFame = UserMO.getUpFameByLevel(curLevel)
		if newFame < needFame then  -- 没有升级
			UserMO.fame_ = newFame
			Notify.notify(LOCAL_FAME_EVENT)
			return UserMO.fameLevel_, UserMO.fame_, false
		end

		while newFame >= needFame do
			curLevel = curLevel + 1
			newFame = newFame - needFame

			UserMO.fameLevel_ = curLevel
			UserMO.fame_ = newFame

			needFame = UserMO.getUpFameByLevel(UserMO.fameLevel_)
			--任务计数
			TaskBO.updateTaskSchedule({kind = TASK_SCHEDULE_KIND_FAME,type = 1})
		end
		Notify.notify(LOCAL_FAME_EVENT)
		return UserMO.fameLevel_, UserMO.fame_, true
	elseif kind == ITEM_KIND_TOPUP then --累计充值金额
		UserMO.topup_ = UserMO.topup_ + count
		local newVip = VipMO.getVipByTopup(UserMO.topup_)
		-- if newVip > UserMO.vip_ then
		-- 	--达到vip专属客服等级
		-- 	if newVip >= PERSONAL_SERVICE_VIP and not RechargeBO.getVipServState() then
		-- 		require("app.dialog.VipServiceDialog").new():push()
		-- 		RechargeBO.saveVipServState()
		-- 	end
		-- end --vip升级

		UserMO.vip_ = newVip
	end
end

-- 用于添加exp等可提升等级的属性值
-- 由于这些属性是由等级值和等级下的具体值两个部分组成，所有需要传递level和value两个值
function UserBO.updateUpgradeResource(kind, level, value, id)
	if kind == ITEM_KIND_EXP then
	elseif kind == ITEM_KIND_FAME then
		gprint("[UserMO] updateUpgradeResource:level:", level, "value:", value)
		local oldFame = UserMO.fame_
		local oldLevel = UserMO.fameLevel_

		UserMO.fame_ = value
		UserMO.fameLevel_ = level

		local totalFame = 0

		local deltaLv = UserMO.fameLevel_ - oldLevel
		for index = oldLevel, (UserMO.fameLevel_ - 1) do
			totalFame = totalFame + UserMO.getUpFameByLevel(index)
		end

		totalFame = totalFame - oldFame + UserMO.fame_

		local up = false
		if UserMO.fameLevel_ ~= oldLevel then 
			up = true 
			local upLv = UserMO.fameLevel_ - oldLevel
			if upLv > 0 then
				for index = 1,upLv do
					--任务计数
					TaskBO.updateTaskSchedule({kind = TASK_SCHEDULE_KIND_FAME,type = 1})
				end
			end
		end

		Notify.notify(LOCAL_FAME_EVENT)
		return UserMO.fameLevel_, UserMO.fame_, up, totalFame
	end
end

-- 专门用于添加体力、繁荣度等有定时器恢复的属性值
-- force：是否强制添加。如果为false，需要判断属性是否达到了上限，如果达到了上限，则为上限值。
function UserBO.addCycleResource(kind, count, force)
	if count < 0 then return false end

	local delta = {}
	delta.kind = kind
	delta.id = 0

	if kind == ITEM_KIND_POWER then
		delta.count = UserMO.power_
		UserMO.power_ = UserMO.power_ + count

		if not force then
			if UserMO.power_ > POWER_MAX_VALUE then UserMO.power_ = POWER_MAX_VALUE end
		end

		delta.count = UserMO.power_ - delta.count

		Notify.notify(LOCAL_POWER_EVENT)
	elseif kind == ITEM_KIND_PROSPEROUS then
		delta.count = UserMO.prosperous_
		UserMO.prosperous_ = UserMO.prosperous_ + count

		if UserMO.prosperous_ > UserMO.maxProsperous_ then UserMO.prosperous_ = UserMO.maxProsperous_ end

		delta.count = UserMO.prosperous_ - delta.count

		local old = UserMO.prosperousLevel_
		UserMO.prosperousLevel_ = UserBO.getProsperousLevel(UserMO.prosperous_)  -- 更新繁荣度等级
		if old ~= UserMO.prosperousLevel_ then  -- 繁荣度等级发生了变化
			UserBO.triggerFightCheck()
		end

		Notify.notify(LOCAL_PROSPEROUS_EVENT)
	end

	UserBO.updateCycleTime(kind)
	return true, delta
end

function UserBO.reduceCycleResource(kind, count)
	if count < 0 then return false end

	if kind == ITEM_KIND_POWER then
		if count > UserMO.power_  then return false end

		UserMO.power_ = UserMO.power_ - count

		Notify.notify(LOCAL_POWER_EVENT)
	elseif kind == ITEM_KIND_PROSPEROUS then
		if count > UserMO.prosperous_ then return false end

		UserMO.prosperous_ = UserMO.prosperous_ - count

		local old = UserMO.prosperousLevel_
		UserMO.prosperousLevel_ = UserBO.getProsperousLevel(UserMO.prosperous_)  -- 更新繁荣度等级
		if old ~= UserMO.prosperousLevel_ then  -- 繁荣度等级发生了变化
			UserBO.triggerFightCheck()
		end

		Notify.notify(LOCAL_PROSPEROUS_EVENT)
	end

	local delta = {}
	delta.kind = kind
	delta.count = -count

	UserBO.updateCycleTime(kind)
	return true, delta
end

function UserBO.updateCycleResource(kind, count)
	local delta = {}

	if kind == ITEM_KIND_POWER then
		if count == UserMO.power_ then return false end
		delta.kind = kind
		delta.count = count - UserMO.power_

		UserMO.power_ = count
		Notify.notify(LOCAL_POWER_EVENT)
	elseif kind == ITEM_KIND_PROSPEROUS then
		if count == UserMO.prosperous_ then return false end
		delta.kind = kind
		delta.count = count - UserMO.prosperous_

		UserMO.prosperous_ = count

		local old = UserMO.prosperousLevel_
		UserMO.prosperousLevel_ = UserBO.getProsperousLevel(UserMO.prosperous_)  -- 更新繁荣度等级
		if old ~= UserMO.prosperousLevel_ then  -- 繁荣度等级发生了变化
			UserBO.triggerFightCheck()
		end

		Notify.notify(LOCAL_PROSPEROUS_EVENT)
	end

	UserBO.updateCycleTime(kind)
	return true, delta
end

function UserBO.addAwards(awards)
	if not awards then return end

	local ret = {}
	ret.levelUp = false -- 是否提升等级
	ret.fameUp = false -- 声望是否等级提升
	ret.awards = {}

	awards = UserBO.arrangeAwards(awards)

	-- if awards and #awards > 0 then
	-- 	for index = 1, #awards do
	-- 		awards[index].kind = awards[index].type
	-- 	end
	-- end

	local change = {}
	local haveHero = false
	for index = 1, #awards do
		local award = awards[index]
		if award.type == ITEM_KIND_EXP then  -- 奖励exp
			local _, _, up = UserBO.addUpgradeResouce(award.type, award.count)
			ret.levelUp = up
			ret.awards[#ret.awards + 1] = award
		elseif award.type == ITEM_KIND_PROSPEROUS then
			local ok, res = UserBO.addCycleResource(award.type, award.count)
			if ok then ret.awards[#ret.awards + 1] = res end
		elseif award.type == ITEM_KIND_FAME then
			local _, _, up = UserBO.addUpgradeResouce(ITEM_KIND_FAME, award.count)
			ret.fameUp = up
			ret.awards[#ret.awards + 1] = {kind = ITEM_KIND_FAME, count = award.count}
		elseif award.type == ITEM_KIND_EQUIP then
			EquipMO.equip_[award.keyId] = {equipId = award.id, level = 1, exp = 0, keyId = award.keyId, formatPos = 0}
			ret.awards[#ret.awards + 1] = {kind = ITEM_KIND_EQUIP, id = award.id, count = 1, keyId = award.keyId}
			change[9] = true
			--TK统计 装备获得
			TKGameBO.onEvnt(TKText.eventName[7], {equipId = award.id})
		elseif award.type == ITEM_KIND_PART then
			PartMO.part_[award.keyId] = {partId = award.id, upLevel = 0, refitLevel = 0, keyId = award.keyId, typePos = 0}
			-- ret.awards[#ret.awards + 1] = PartMO.part_[award.keyId]
			ret.awards[#ret.awards + 1] = {kind = ITEM_KIND_PART, id = award.id, count = 1, keyId = award.keyId}
			Notify.notify(LOCLA_PART_EVENT)
			--TK统计 配件获得
			TKGameBO.onEvnt(TKText.eventName[9], {partId = award.id})
		elseif award.type == ITEM_KIND_POWER then
			UserBO.addCycleResource(award.type, award.count, true)
			ret.awards[#ret.awards + 1] = award
		elseif award.type == ITEM_KIND_RED_PACKET then  -- 红包
			local propDB = PropMO.queryPropById(award.id)
			local effectValue = json.decode(propDB.effectValue)
			local coinCount = 0
			if effectValue and effectValue[1] and effectValue[1][1] then coinCount = effectValue[1][1] * award.count end

			local awd = {kind = ITEM_KIND_COIN, count = coinCount}
			UserBO.addResource(awd.kind, awd.count)
			ret.awards[#ret.awards + 1] = awd
		elseif award.type == ITEM_KIND_HERO then
			haveHero = true
			ret.awards[#ret.awards + 1] = award
		else
			if award.type == ITEM_KIND_TANK then
				change[3] = true
			end
			UserBO.addResource(award.type, award.count, award.id)
			ret.awards[#ret.awards + 1] = award
		end
	end
	if haveHero then
		HeroBO.updateMyHeros()
	end

	if change[3] then UserBO.triggerFightCheck() end

	-- 装备
	if change[9] then Notify.notify(LOCAL_EQUIP_EVENT) end
	return ret
end

-- 将奖励awards中的
function UserBO.arrangeAwards(awards)
	local ret = {}

	local function add(award)
		if award.id and award.id == 0 then award.id = nil end

		if award.kind == ITEM_KIND_EQUIP or award.kind == ITEM_KIND_PART then  -- 不累计个数
			ret[#ret + 1] = award
		else
			for index = 1, #ret do
				local r = ret[index]
				if r.kind == award.kind then
					if r.id and award.id then
						if r.id == award.id then  -- 找到了
							r.count = r.count + award.count
							return
						end
					elseif not r.id and not award.id then  -- 找到了
						r.count = award.count
						return
					end
				end
			end
			ret[#ret + 1] = award
		end
	end

	for index = 1, #awards do
		local award = awards[index]
		if not table.isexist(award, "kind") then award.kind = award.type end

		add(award)
	end
	return ret
end

function UserBO.asynLordData(doneCallback)
	function parseLordData(name, code, data)
		LoginMO.isInLogin_ = true -- 成功登录进入了游戏

		WorldMO.currentPos_ = nil

		if handleCode(name, code, data) then return end

		UserBO.updateGetLord(data)

		-- 科技数据	
		local data = SocketReceiver.dig("GetScience")
		ScienceBO.update(data.data)

		--社交数据
		local data = SocketReceiver.dig("GetFriend")
		SocialityBO.updateFriend(data.data)

		--好友祝福
		local data = SocketReceiver.dig("GetBless")
		SocialityBO.updateBlesses(data.data)
		
		--收藏数据
		-- local data = SocketReceiver.dig("GetStore")
		SocialityBO.updateStore()

		-- 坦克数据		
		local data = SocketReceiver.dig("GetTank")
		TankBO.update(data.data)

		local data = SocketReceiver.dig("GetArmy")
		ArmyBO.update(data.data)

		-- 将领数据	
		local data = SocketReceiver.dig("GetMyHeros")
		HeroBO.update(data.data)

		local data = SocketReceiver.dig("GetInvasion")
		ArmyBO.updateInvasions(data.data)

		local data = SocketReceiver.dig("GetAid")
		ArmyBO.updateAids(data.data)

		local data = SocketReceiver.dig("GetProp")
		PropBO.update(data.data)

		local data = SocketReceiver.dig("GetEquip")
		EquipBO.update(data.data)

		local data = SocketReceiver.dig("GetPart")
		PartBO.update(data.data)

		local data = SocketReceiver.dig("GetChip")
		PartBO.updateChip(data.data)

		local data = SocketReceiver.dig("GetCombat")
		CombatBO.update(data.data)
		
		CombatMO.combatNeedFresh_ = true

		local data = SocketReceiver.dig("GetSkill")
		SkillBO.update(data.data)

		local data = SocketReceiver.dig("GetEffect")
		EffectBO.update(data.data)

		local data = SocketReceiver.dig("GetChat")
		ChatBO.update(data.data)

		--签到数据
		local data = SocketReceiver.dig("GetSign")
		SignBO.update(data.data)

		local data = SocketReceiver.dig("EveLogin")
		SignBO.updateEveryLogin(data.data)

		--任务数据
		local data = SocketReceiver.dig("GetMajorTask")
		TaskBO.init()
		TaskBO.updateMajorTask(data.data)

		local data = SocketReceiver.dig("GetDayiyTask")
		TaskBO.updateDaylyTask(data.data)

		local data = SocketReceiver.dig("GetLiveTask")
		TaskBO.updateLiveTask(data.data)
		
		local data = SocketReceiver.dig("GetForm")
		TankBO.updateForm(data.data)

		local data = SocketReceiver.dig("GetResource")
		UserBO.updateGetResource(data.data)

		local data = SocketReceiver.dig("GetMailList")
		MailBO.updateMails(data.data)

		local data = SocketReceiver.dig("GetLotteryEquip")
		LotteryBO.updateLotteryEquip(data.data)

		local data = SocketReceiver.dig("GetLotteryExplore")
		LotteryBO.updateTreasureFreeTimes(data.data)
		
		local data = SocketReceiver.dig("GetArena")
		ArenaBO.update(data.data)

		ActivityBO.readConfig()

		local data = SocketReceiver.dig("GetActivityList")
		ActivityBO.update(data.data)
		ActivityMO.clickView_ = false

		ActivityBO.adjustConfig()

		local data = SocketReceiver.dig("GetActionCenter")
		ActivityCenterBO.update(data.data)

		local data = SocketReceiver.dig("GetActEDayPay")
		ActivityCenterBO.updateActEDayPay(data.data)
		
		local data = SocketReceiver.dig("GetStaffing")
		if data then StaffBO.updateGetStaffing(data.data) end

		local data = SocketReceiver.dig("GetSeniorMap")
		if data then StaffBO.updateGetSeniorMap(data.data) end
		
		WorldBO.init()

		RankMO.myRank_ = {}
		RankMO.ranks = {}
		RankBO.init()

		--初始化新手引导
		NewerBO.init()

		SecretaryBO.updateWild() -- 根据Mill数据更新秘书

		-- PartBO.check()

		--根据等级获取军团数据
		if UserMO.level_ >= BuildMO.getOpenLevel(BUILD_ID_PARTY) then
			scheduler.performWithDelayGlobal(function()
		            PartyBO.asynGetParty(function(success, partyData)
		            		if success then
				            	gdump(partyData,"partyData===")
				            	if partyData then
				            		if PartyMO.myJob >= PARTY_JOB_OFFICAIL then
				            			PartyBO.asynPartyApplyList()
				            		end
				            		PartyBO.asynGetPartyMember(nil,1)
				            	end
				            end
				            
			            	if doneCallback then doneCallback() end
		            	end, 0)
		            PartyBO.asynApplyList()
	            end, 0.05)
		else
			if doneCallback then doneCallback() end
		end

		ActivityCenterMO.boss_ = {}
		
		if ActivityCenterMO.isBossOpen_ and UserMO.level_ >= ACTIVITY_BOSS_OPEN_LEVEL then  -- 世界BOSS开放
			ActivityCenterBO.asynGetBoss(nil)
		end
	end

	SocketReceiver.clear()

	UserMO.startCheckFight_ = false

	ArmyMO.dirtyArmyData_ = true
	TankMO.dirtyTankData_ = true
	HeroMO.dirtyHeroData_ = true
	SkillMO.dirtySkillData_ = true
	ScienceMO.dirtyScienceData_ = true
	PartyMO.dirtyPartyScienceData_ = true

	BuildBO.asynGetBuilding()  -- 含有队列数据信息的协议先调用

	PartyBO.asynGetPartyScience()

	SocketWrapper.wrapSends({
		NetRequest.new("GetTank"),  -- 含有队列数据信息的协议先调用
		NetRequest.new("GetProp"),
		NetRequest.new("GetArmy"),
		NetRequest.new("GetInvasion"),
		NetRequest.new("GetAid"),
		NetRequest.new("GetScience"),
	})

	scheduler.performWithDelayGlobal(function()
			SocketWrapper.wrapSends({
    			NetRequest.new("GetForm"),
		    	NetRequest.new("GetResource"),
		    	NetRequest.new("GetEquip"),
		    	NetRequest.new("GetPart"),
		    	NetRequest.new("GetChip"),
		    	NetRequest.new("GetCombat"),
		    	NetRequest.new("GetFriend"),
		    	NetRequest.new("GetBless"),
		    	NetRequest.new("GetEffect"),
		    })
		end, 0.3)

	scheduler.performWithDelayGlobal(function()
			SocketWrapper.wrapSends({
		    	NetRequest.new("GetMyHeros"),  -- 在GetArmy协议之后才能拉取
				NetRequest.new("GetSkill"),
				-- NetRequest.new("GetStore"),
				NetRequest.new("GetChat"),
				NetRequest.new("GetSign"),
				NetRequest.new("EveLogin"),
				NetRequest.new("GetMajorTask"),
				NetRequest.new("GetDayiyTask"),
				NetRequest.new("GetLiveTask"),
		    })
		end, 0.7)

	scheduler.performWithDelayGlobal(function()
			SocketWrapper.wrapSends({
				NetRequest.new("GetMailList"),
				NetRequest.new("GetLotteryEquip"),
				NetRequest.new("GetLotteryExplore"),
				NetRequest.new("GetArena"),
				NetRequest.new("GetActivityList"),
				NetRequest.new("GetActionCenter"),
				NetRequest.new("GetActEDayPay"),
				NetRequest.new("GetStaffing"),
				NetRequest.new("GetSeniorMap")
			})
		end, 1.2)

    scheduler.performWithDelayGlobal(function() SocketWrapper.wrapSend(parseLordData, NetRequest.new("GetLord")) end, 2)
end

function UserBO.asynGetLord(doneCallback)
	local function parseGetLord(name, code, data)
		if not handleCode(name, code, data) then
			local awards = UserBO.updateGetLord(data)
			if doneCallback then doneCallback(true, awards) end
		else
			if doneCallback then doneCallback(false) end
		end
	end

	SocketWrapper.wrapSend(parseGetLord, NetRequest.new("GetLord"))
end

function UserBO.asynGetResouce(doneCallback)
	local function parseResource(name, code, data)
		if not handleCode(name, code, data) then
			local delta = UserBO.updateGetResource(data)
			UiUtil.showAwards({awards = delta})

			if doneCallback then doneCallback(true) end
		else
			if doneCallback then doneCallback(false) end
		end
	end

	SocketWrapper.wrapSend(parseResource, NetRequest.new("GetResource"))
end

function UserBO.asynBuyPower(doneCallback)
	local function parseBuyPower(name, code, data)
		if not handleCode(name, code, data) then
			gdump(data, "[UserBO] buy power")
			UserMO.powerBuy_ = UserMO.powerBuy_ + 1  -- 购买次数加1

			--TK统计
			TKGameBO.onUseCoinTk(data.gold,TKText[10][9],TKGAME_USERES_TYPE_UPDATE)

			UserBO.updateResource(ITEM_KIND_COIN, data.gold)
			local _, award = UserBO.updateCycleResource(ITEM_KIND_POWER, data.power)

			UiUtil.showAwards({awards = {award}})

			if doneCallback then doneCallback(true) end
		else
			if doneCallback then doneCallback(false) end
		end
	end

	SocketWrapper.wrapSend(parseBuyPower, NetRequest.new("BuyPower"))
end

function UserBO.asynUpRank(doneCallback)
	local function parseUpRank(name, code, data)
		if not handleCode(name, code, data) then
			gdump(data, "[UserBO] up rank")
			UserMO.rank_ = UserMO.rank_ + 1
			--任务计数
			TaskBO.updateTaskSchedule({kind = TASK_SCHEDULE_KIND_RANK,type = 1,rankId = UserMO.rank_})
			--TK统计
			TKGameBO.onUseResTk(RESOURCE_ID_STONE,data.stone,TKText[21],TKGAME_USERES_TYPE_UPDATE)

			UserBO.updateResource(ITEM_KIND_RESOURCE, data.stone, RESOURCE_ID_STONE)

			if doneCallback then doneCallback(true) end
		else
			if doneCallback then doneCallback(false) end
		end
	end

	SocketWrapper.wrapSend(parseUpRank, NetRequest.new("UpRank"))
end

function UserBO.asynUpCommand(doneCallback, useCoin)
	local function parseUpCommand(name, code, data)
		if not handleCode(name, code, data) then
			gdump(data, "[UserBO] up command")

			if data.success then
				UserMO.command_ = UserMO.command_ + 1
			else
			end

			local res = {}
			if useCoin then
				--TK统计
				TKGameBO.onUseCoinTk(data.gold,TKText[22],TKGAME_USERES_TYPE_UPDATE)

				res[#res + 1] = {kind = ITEM_KIND_COIN, count = data.gold}
			else
				res[#res + 1] = {kind = ITEM_KIND_PROP, count = data.book, id = PROP_ID_COMMAND_BOOK}
			end
			UserBO.updateResources(res)

			if data.success then
				UserBO.triggerFightCheck()
			end

			if doneCallback then doneCallback(true, data.success) end

			--引导触发
			NewerBO.showNewerGuide()
		else
			if doneCallback then doneCallback(false) end
		end
	end

	SocketWrapper.wrapSend(parseUpCommand, NetRequest.new("UpCommand", {useGold = useCoin}))
end

function UserBO.asynBuyPros(doneCallback)
	local function parseBuyPros(name, code, data)
		if not handleCode(name, code, data) then
			gdump(data, "[UserBO] buy pros")
			--TK统计
			TKGameBO.onUseCoinTk(data.gold,TKText[10][10],TKGAME_USERES_TYPE_UPDATE)

			UserBO.updateResource(ITEM_KIND_COIN, data.gold)
			UserBO.updateCycleResource(ITEM_KIND_PROSPEROUS, UserMO.maxProsperous_)

			if doneCallback then doneCallback(true) end
		else
			if doneCallback then doneCallback(false) end
		end
	end

	SocketWrapper.wrapSend(parseBuyPros, NetRequest.new("BuyPros"))
end

function UserBO.asynBuyFame(doneCallback, fameType)
	local function parseBuyFame(name, code, data)
		if not handleCode(name, code, data) then
			gdump(data, "[UserBO] buy fame")

			UserMO.canBuyFame_ = false

			local res = {}
			if FAME_MEDAL_TAKE[fameType][2] == 1 then  -- 宝石授勋
				--TK统计
				TKGameBO.onUseResTk(RESOURCE_ID_STONE,data.stone,TKText[23],TKGAME_USERES_TYPE_UPDATE)

				res[#res + 1] = {kind = ITEM_KIND_RESOURCE, count = data.stone, id = RESOURCE_ID_STONE}
			else
				--TK统计
				TKGameBO.onUseCoinTk(data.gold,TKText[23],TKGAME_USERES_TYPE_UPDATE)
				
				res[#res + 1] = {kind = ITEM_KIND_COIN, count = data.gold}
			end
			UserBO.updateResources(res)

			local level, value, up, delta = UserBO.updateUpgradeResource(ITEM_KIND_FAME, data.fameLv, data.fame)
			if doneCallback then doneCallback(true, up, delta) end
		else
			if doneCallback then doneCallback(false) end
		end
	end

	SocketWrapper.wrapSend(parseBuyFame, NetRequest.new("BuyFame", {type = fameType}))
end

function UserBO.asynClickFame(doneCallback)
	local function parseClickFame(name, code, data)
		if not handleCode(name, code, data) then
			gdump(data, "[UserBO] click fame")
			UserMO.canClickFame_ = false

			local level, value, up, delta = UserBO.updateUpgradeResource(ITEM_KIND_FAME, data.fameLv, data.fame)
			if doneCallback then doneCallback(true, up, delta) end
		else
			if doneCallback then doneCallback(false) end
		end
	end

	SocketWrapper.wrapSend(parseClickFame, NetRequest.new("ClickFame"))
end

function UserBO.asynSetData(doneCallback, type, value)
	local function parseSetData(name, code, data)
		if not handleCode(name, code, data) then
		end

		-- gdump(data, "UserBO.asynSetData")
		if doneCallback then doneCallback() end
	end

	SocketWrapper.wrapSend(parseSetData, NetRequest.new("SetData", {type = type, value = value}))
end

function UserBO.asynSetPortrait(doneCallback, portrait, pendant)
	gprint("UserBO.asynSetPortrait portrait:", portrait, "pendant:", pendant)
	local function parseSetPortrait(name, code, data)
		if not handleCode(name, code, data) then
			UserMO.portrait_ = portrait
			UserMO.pendant_ = pendant

			if doneCallback then doneCallback(true) end
		else
			if doneCallback then doneCallback(false) end
		end
	end

	local value = pendant * 100 + portrait
	SocketWrapper.wrapSend(parseSetPortrait, NetRequest.new("SetPortrait", {portrait = value}))
end

function UserBO.asynBuyBuild(doneCallback)
	local function parseBuyBuild(name, code, data)
		if not handleCode(name, code, data) then
			if table.isexist(data, "gold") then 
				--TK统计
				TKGameBO.onUseCoinTk(data.gold,TKText[37],TKGAME_USERES_TYPE_UPDATE)

				UserBO.updateResource(ITEM_KIND_COIN, data.gold) 
			end

			UserMO.buildCount_ = UserMO.buildCount_ + 1

			Notify.notify(LOCAL_BUY_BUILD_EVENT)
		end

		if doneCallback then doneCallback() end
	end

	SocketWrapper.wrapSend(parseBuyBuild, NetRequest.new("BuyBuild"))
end

function UserBO.asynGiftCode(doneCallback, content)
	local function parseGiftCode(name, code, data)
		if not handleCode(name, code, data) then
			local awards = nil
			if table.isexist(data, "award") then awards = PbProtocol.decodeArray(data["award"]) end

			local statisticsAward = nil
			if awards then
				statisticsAward = UserBO.addAwards(awards)
			end

			if doneCallback then doneCallback(data.state, statisticsAward) end
		else
			if doneCallback then doneCallback() end
		end
	end

	SocketWrapper.wrapSend(parseGiftCode, NetRequest.new("GiftCode", {code = content}))
end

-- 领取在线奖励
function UserBO.asynOnlineAward(doneCallback)
	local function parseGiftCode(name, code, data)
		if not handleCode(name, code, data) then
			gdump(data, "UserBO.asynOnlineAward")

			UserMO.onlineAwardIndex_ = data.id

			if UserMO.onlineAwardIndex_ >= UserMO.getOnlineAwardTotalNum() then -- 都已经领完了
				UserMO.onlineCdTime_ = 0
			else
				UserMO.onlineCdTime_ = UserMO.getOnlineAwardByIndex(UserMO.onlineAwardIndex_ + 1)
			end

			local awards = nil
			if table.isexist(data, "award") then awards = PbProtocol.decodeArray(data["award"]) end

			local statisticsAward = nil
			if awards then
				gdump(awards, "UserBO.asynOnlineAward")
				statisticsAward = UserBO.addAwards(awards)
			end

			if doneCallback then doneCallback(data.id, statisticsAward) end
		else
			if doneCallback then doneCallback() end
		end
	end

	SocketWrapper.wrapSend(parseGiftCode, NetRequest.new("OlAward", {code = content}))
end
